/*
 * NoteSpectrum.cpp
 *
 *  Created on: 27 déc. 2023
 *      Author: fanch
 */

#include "NoteSpectrum.h"

NoteSpectrum::NoteSpectrum(LADSPA_Data* data, unsigned long sample_count,  unsigned long sample_rate) {
	m_sample_rate = sample_rate;
	m_sample_count = sample_count;
	_read(data);
}

NoteSpectrum::~NoteSpectrum() {
	// TODO Auto-generated destructor stub
}


void NoteSpectrum::_read(LADSPA_Data *data) {
	// assume that each data item in [0,1]
	const int istart = 28;
	int ileft, iright;
	float current_freq;
	memset(m_values, 0, sizeof(NoteValue)*NOTE_COUNT);
	int imax=0, jmax=0, vmax=0;
	float max=0;
	for(int i=0; i<m_sample_count; i++ ){
		if(data[i]>max){
			max=data[i];
			imax=i;
		}
	}


	// start with midi note istart (to have a suffisant frequncy)
	for(int i=istart; i<NOTE_COUNT; i++){
		const float target_frequency = Notes[i].frequency;
		if(i==127){
			i = 127;
		}
		if(i<=istart){
			ileft = istart-1;
		}else{
			ileft = frequency_to_index(midi_to_frequency(i-0.5));
		}

		if(i==NOTE_COUNT-1){
			iright = istart + (frequency_to_index(target_frequency)-ileft);
		}else{
			iright = frequency_to_index(midi_to_frequency(i+0.5));
		}
		set_value(data, ileft, i, iright, m_values[i]);

		if(m_values[i].velocity>vmax){
			vmax=m_values[i].velocity;
			jmax=i;
		}
	}
	return;
}

const Note Notes[128] = {
		Note(0),
		Note(1),
		Note(2),
		Note(3),
		Note(4),
		Note(5),
		Note(6),
		Note(7),
		Note(8),
		Note(9),
		Note(10),
		Note(11),
		Note(12),
		Note(13),
		Note(14),
		Note(15),
		Note(16),
		Note(17),
		Note(18),
		Note(19),
		Note(20),
		Note(21),
		Note(22),
		Note(23),
		Note(24),
		Note(25),
		Note(26),
		Note(27),
		Note(28),
		Note(29),
		Note(30),
		Note(31),
		Note(32),
		Note(33),
		Note(34),
		Note(35),
		Note(36),
		Note(37),
		Note(38),
		Note(39),
		Note(40),
		Note(41),
		Note(42),
		Note(43),
		Note(44),
		Note(45),
		Note(46),
		Note(47),
		Note(48),
		Note(49),
		Note(50),
		Note(51),
		Note(52),
		Note(53),
		Note(54),
		Note(55),
		Note(56),
		Note(57),
		Note(58),
		Note(59),
		Note(60),
		Note(61),
		Note(62),
		Note(63),
		Note(64),
		Note(65),
		Note(66),
		Note(67),
		Note(68),
		Note(69),
		Note(70),
		Note(71),
		Note(72),
		Note(73),
		Note(74),
		Note(75),
		Note(76),
		Note(77),
		Note(78),
		Note(79),
		Note(80),
		Note(81),
		Note(82),
		Note(83),
		Note(84),
		Note(85),
		Note(86),
		Note(87),
		Note(88),
		Note(89),
		Note(90),
		Note(91),
		Note(92),
		Note(93),
		Note(94),
		Note(95),
		Note(96),
		Note(97),
		Note(98),
		Note(99),
		Note(100),
		Note(101),
		Note(102),
		Note(103),
		Note(104),
		Note(105),
		Note(106),
		Note(107),
		Note(108),
		Note(109),
		Note(110),
		Note(111),
		Note(112),
		Note(113),
		Note(114),
		Note(115),
		Note(116),
		Note(117),
		Note(118),
		Note(119),
		Note(120),
		Note(121),
		Note(122),
		Note(123),
		Note(124),
		Note(125),
		Note(126),
		Note(127)
};

